<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'coupon';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 实例化
include_once (ROOT_PATH . 'include/coupon.class.php');
$dou_coupon = new Coupon();

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/coupon/', null, 'jpg,gif,png', '2048'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 优惠券套餐列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['coupon']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['coupon_add'],
            'href' => 'coupon.php?rec=add' 
    ));
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('coupon') . " ORDER BY sort ASC, id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, 'coupon.php');
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $coupon_list[] = array (
                "id" => $row['id'],
                "name" => $row['name'],
                "coupon_sn" => $row['coupon_sn'],
                "type" => $_LANG['coupon_type_' . $row['type']],
                "money" => $dou->price_format($row['money']),
                "condition" => $row['condition'],
                "start_time" => date("Y-m-d", $row['start_time']),
                "end_time" => date("Y-m-d", $row['end_time']),
                "status" => $dou->data_lang_format('coupon_status_', $row['status']),
                "sort" => $row['sort'],
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('coupon_list', $coupon_list);
    
    $smarty->display('coupon.htm');
} 

/**
 * +----------------------------------------------------------
 *  优惠券套餐添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['coupon_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['coupon'],
            'href' => 'coupon.php' 
    ));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $firewall->get_token());
 
    // 初始化投票时间
    $coupon['start_time'] = date("Y-m-d H:i:s", time());
    $coupon['end_time'] = date("Y-m-d H:i:s", strtotime("+30day", time()));
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('coupon', $coupon);
    $smarty->assign('btn_lang', $dou->btn_lang('coupon', '', 'name, brief'));
    
    $smarty->display('coupon.htm');
} 

elseif ($rec == 'insert') {
    // 判断是否为空
    $wrong = $check->fn_empty('coupon', 'name, face_value, condition');
 
    // 显示错误提示
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $dou->dou_msg($wrong[$key]);;
        }
    }
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
 
    // 格式化数据
    $coupon_sn = $dou_coupon->create_coupon_sn();
    $start_time = $_POST['start_time'] ? strtotime($_POST['start_time']) : '';
    $end_time = $_POST['end_time'] ? strtotime($_POST['end_time']) : '';
    $add_time = time();
    
    $sql = "INSERT INTO " . $dou->table('coupon') . " (id, name, coupon_sn, face_value, `condition`, start_time, end_time, brief, status, add_time)" . " VALUES (NULL, '$_POST[name]', '$coupon_sn', '$_POST[face_value]', '$_POST[condition]', '$start_time', '$end_time', '$_POST[brief]', '$_POST[status]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['coupon_add'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['coupon_add'] . $_LANG['success'], 'coupon.php');
} 

/**
 * +----------------------------------------------------------
 *  优惠券套餐编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['coupon_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['coupon'],
            'href' => 'coupon.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $coupon = $dou->get_row('coupon', '*', "id = '$id'");
    
    // 格式化数据
    $coupon['start_time'] = $coupon['start_time'] ? date("Y-m-d H:i:s", $coupon['start_time']) : date("Y-m-d H:i:s", time());
    $coupon['end_time'] = $coupon['end_time'] ? date("Y-m-d H:i:s", $coupon['end_time']) : date("Y-m-d H:i:s", strtotime("+30day", time()));
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('coupon', $coupon);
    $smarty->assign('btn_lang', $dou->btn_lang('coupon', $id, 'name, brief'));
    
    $smarty->display('coupon.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 判断是否为空
    $wrong = $check->fn_empty('coupon', 'name, face_value, condition');
 
    // 显示错误提示
    if ($wrong) {
        foreach ($wrong as $key => $value) {
            $dou->dou_msg($wrong[$key]);;
        }
    }
    
    // 格式化数据
    $start_time = $_POST['start_time'] ? strtotime($_POST['start_time']) : '';
    $end_time = $_POST['end_time'] ? strtotime($_POST['end_time']) : '';
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('coupon') . " SET name = '$_POST[name]', type = '$_POST[type]', face_value = '$_POST[face_value]', `condition` = '$_POST[condition]', start_time = '$start_time', end_time = '$end_time', brief = '$_POST[brief]', status = '$_POST[status]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['coupon_edit'] . ': ' . $_POST['name']);
    $dou->dou_msg($_LANG['coupon_edit'] . $_LANG['success'], 'coupon.php');
}

/**
 * +----------------------------------------------------------
 * 优惠券套餐删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的user_id
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'coupon.php');
    $name = $dou->get_one("SELECT name FROM " . $dou->table('coupon') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['coupon_del'] . ': ' . $name);
        $dou->delete('coupon', "id = $id", 'coupon.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $name, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'coupon.php', '', '30', "coupon.php?rec=del&id=$id");
    }
}

?>