<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'coupon';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

include_once (ROOT_PATH . 'include/coupon.class.php');
$dou_coupon = new Coupon();

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * VIP开通记录
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['coupon_log']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['coupon_list'],
            'href' => 'coupon.php' 
    ));
    
    // SESSION 与 REQUEST 互转
    if ($_REQUEST['key']) {
        $_SESSION['req'] = $_REQUEST;
    } else {
        if (isset($_REQUEST['menu'])) unset($_SESSION['req']);
        foreach ((array)$_SESSION['req'] as $key => $value) {
            $_REQUEST[$key] = $value;
        }
    }

    // 验证并获取合法的REQUEST
    $coupon_id = $check->is_number($_REQUEST['coupon_id']) ? $_REQUEST['coupon_id'] : '';
    $time_start = isset($_REQUEST['time_start']) ? trim($_REQUEST['time_start']) : '';
    $time_end = isset($_REQUEST['time_end']) ? trim($_REQUEST['time_end']) : '';
    
    // 初始化
    $page_url = 'coupon_log.php';

    // 筛选.类型
    if ($coupon_id) {
        $where = $where . " AND coupon_id = '$coupon_id'";
        $page_url = $page_url . "&coupon_id=$coupon_id";
    }
 
    // 筛选.时间
    if ($time_start) {
        $where = $where . " AND use_time > '" . strtotime($time_start) . "'";
        $page_url = $page_url . "&time_start=$time_start";
    }
    if ($time_end) {
        $where = $where . " AND use_time < '" . strtotime($time_end) . "'";
        $page_url = $page_url . "&time_end=$time_end";
    }
 
    // 把第一个AND替换成WHERE
    $where = $_SESSION['where'] = $dou->where($where);
 
    // 未加入分页条件的SQL语句
    $sql = "SELECT * FROM " . $dou->table('coupon_log') . $where . " ORDER BY id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $limit = $dou->pager($sql, 15, $page, $dou->param($page_url));
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $coupon = $dou->get_row('coupon', '*', "id = '$row[coupon_id]'");
        if ($coupon) {
            $coupon['money'] = $dou->price_format($coupon['money']);
            $coupon['condition'] = $coupon['condition'];
            $coupon['start_time'] = date("Y-m-d", $coupon['start_time']);
            $coupon['end_time'] = date("Y-m-d", $coupon['end_time']);
            $coupon['status'] = $dou_coupon->status($row['coupon_id']);
        }
        
        $log_list[] = array (
                "id" => $row['id'],
                "user" => $dou->user_basic($row['user_id']),
                "coupon" => $dou->get_row('coupon', '*', "id = '$row[coupon_id]'"),
                "type" => $_LANG['coupon_type_' . $coupon['type']],
                "money" => $dou->price_format($coupon['money']),
                "condition" => $coupon['condition'],
                "get_time" => date("Y-m-d", $row['get_time']),
                "use_time" => $row['use_time'] ? date("Y-m-d", $row['use_time']) : '-',
                "order_sn" => $row['order_sn'] ? $row['order_sn'] : '-',
                "status" => $dou->data_lang_format('coupon_log_status_', $row['status']),
                "add_time" => date("Y-m-d", $row['add_time'])
        );
    }
    
    // 赋值给模板
    $smarty->assign('req', $_REQUEST);
    $smarty->assign('log_list', $log_list);
    
    $smarty->display('coupon_log.htm');
}

/**
 * +----------------------------------------------------------
 * 记录删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'coupon_log.php');
 
    // 获取购买信息
    $log = $dou->get_row('coupon_log', '*', "id = '$id'");
    $user = $dou->user_basic($log['user_id']);
    $coupon = $dou->get_row('coupon', '*', "id = '$log[coupon_id]'");
    
    if (isset($_POST['confirm'])) {
        $dou->create_admin_log($_LANG['coupon_log_del'] . ': ' . $user['username'] . '-' . $coupon['name']);
        $dou->delete('coupon_log', "id = '$id'", 'coupon_log.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $user['username'] . '-' . $coupon['name'], $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'coupon_log.php', '', '30', "coupon_log.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            $dou->del_all('coupon_log', $_POST['checkbox'], 'id');
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['select_empty']);
    }
}

?>