<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
if (!defined('IN_DOUCO')) {
    die('Hacking attempt');
}
class Coupon {
    /**
     * +----------------------------------------------------------
     * 获取优惠券列表
     * +----------------------------------------------------------
     */
    function get_coupon_list($user_id = '') {
        $user_id = $user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id'];
        $time = time();
        
        $sql = "SELECT * FROM " . $GLOBALS['dou']->table('coupon') . " WHERE start_time <= '$time' AND end_time > '$time' AND status = '1' ORDER BY sort ASC, id DESC";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            // 多语言
            $row = $GLOBALS['dou']->lang_box($row, 'coupon', 'name, brief');
            
            $status = $this->status($row['id'], $user_id);
            $coupon_list[] = array (
                    "id" => $row['id'],
                    "name" => $row['name'],
                    "coupon_sn" => $row['coupon_sn'],
                    "type" => $_LANG['coupon_type_' . $row['type']],
                    "money" => $GLOBALS['dou']->price_format($row['money']),
                    "condition" => $row['condition'],
                    "start_time" => date("Y-m-d", $row['start_time']),
                    "end_time" => date("Y-m-d", $row['end_time']),
                    "brief" => $row['brief'],
                    "class" => $status['value'] != 'get' ? ' got' : '',
                    "status" => $status
            );
        }
        
        return $coupon_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 获取用户已经领取的优惠券列表
     * +----------------------------------------------------------
     */
    function get_user_coupon_list($user_id = '') {
        $user_id = $user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id'];
        
        $sql = "SELECT * FROM " . $GLOBALS['dou']->table('coupon_log') . " WHERE user_id = '$user_id' AND status = '0' ORDER BY id DESC";
        $query = $GLOBALS['dou']->query($sql);
        while ($row = $GLOBALS['dou']->fetch_array($query)) {
            if (!$this->if_expires($row['coupon_id'])) {
                $coupon = $this->get_coupon($row['coupon_id']);
                
                // 多语言
                $coupon = $GLOBALS['dou']->lang_box($coupon, 'coupon', 'name, brief');

                $coupon_list[] = array (
                        "id" => $coupon['id'],
                        "name" => $coupon['name'],
                        "condition" => $coupon['condition'],
                        "condition_text" => $coupon['condition_text'],
                        "used" => $coupon['use_time'] ? true : false,
                        "brief" => $coupon['brief']
                );
            }
        }
        
        return $coupon_list;
    }
 
    /**
     * +----------------------------------------------------------
     * 获取优惠券信息
     * +----------------------------------------------------------
     */
    function get_coupon($coupon_id) {
        $coupon = $GLOBALS['dou']->get_row('coupon', '*', "id = '$coupon_id'");
     
        if ($coupon)
            $coupon['condition_text'] = preg_replace('/d%/Ums', $GLOBALS['dou']->price_format($coupon['condition']), $GLOBALS['_LANG']['coupon_condition_text']);
        
        return $coupon;
    }
 
    /**
     * +----------------------------------------------------------
     * 计算使用优惠券后的订单金额
     * +----------------------------------------------------------
     */
    function discount($coupon_id, $item_amount, $user_id = '') {
        $user_id = $user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id'];
     
        $discount = array();
        
        if ($coupon_id && $GLOBALS['dou']->value_exist('coupon_log', 'coupon_id', $coupon_id, "user_id = '$user_id'")) {
            if (!$this->if_expires($coupon_id)) {
                $time = time();
                $coupon = $GLOBALS['dou']->get_row('coupon', '*', "start_time <= '$time' AND end_time > '$time' AND status = '1' AND id = '$coupon_id'");
                
                if ($coupon) {
                    if ($item_amount >= $coupon['condition']) {
                        if ($coupon['type'] == 'percent') {
                            $coupon_amount = $item_amount * ($coupon['face_value'] / 100);
                            $item_amount = number_format($item_amount - $coupon_amount, $GLOBALS['_CFG']['price_decimal'], '.', '');

                            $discount = array (
                                    "coupon_id" => $coupon_id,
                                    "type" => $coupon['type'],
                                    "amount" => $coupon_amount,
                                    "item_amount" => $item_amount
                            );
                        } else {
                            $item_amount = $item_amount - $coupon['face_value'];

                            $discount = array (
                                    "coupon_id" => $coupon_id,
                                    "type" => $coupon['type'],
                                    "amount" => $coupon['face_value'],
                                    "item_amount" => $item_amount
                            );
                        }
                    }
                }
            }
        }
        
        return $discount;
    }
 
    /**
     * +----------------------------------------------------------
     * 优惠卷状态
     * +----------------------------------------------------------
     */
    function status($coupon_id, $user_id = '') {
        $user_id = $user_id ? $user_id : $GLOBALS['_GLOBAL_USER']['user_id'];
     
        $log = $GLOBALS['dou']->get_row('coupon_log', '*', "coupon_id = '$coupon_id' AND user_id = '$user_id'");
        if ($log['use_time']) {
            $status = array (
                    "value" => 'used',
                    "format" => $GLOBALS['_LANG']['coupon_status_used']
            );
        } elseif ($this->if_expires($coupon_id)) {
            $status = array (
                    "value" => 'expires',
                    "format" => $GLOBALS['_LANG']['coupon_status_expires']
            );
        } elseif ($log['get_time']) {
            $status = array (
                    "value" => 'got',
                    "format" => $GLOBALS['_LANG']['coupon_status_got']
            );
        } else {
            $status = array (
                    "value" => 'get',
                    "format" => $GLOBALS['_LANG']['coupon_status_get']
            );
        }
        
        return $status;
    }
 
    /**
     * +----------------------------------------------------------
     * 判断优惠券是否已经过期
     * +----------------------------------------------------------
     */
    function if_expires($coupon_id) {
        $end_time = $GLOBALS['dou']->get_value('coupon', 'end_time', "id = '$coupon_id'");
     
        if (time() > $end_time)
            return true;
    }
    
    /**
     * +----------------------------------------------------------
     * 生成唯一的优惠券编号
     * +----------------------------------------------------------
     */
    function create_coupon_sn() {
        // 随机生成订单号
        $coupon_sn = str_pad(mt_rand(1, 99999), 6, '0', STR_PAD_LEFT);

        if ($GLOBALS['dou']->value_exist('coupon', 'coupon_sn', $coupon_sn)) {
            $this->create_coupon_sn();
        }

        return $coupon_sn;
    }
    
}
?>